#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "SmokeBombCosmeticHelperActor.generated.h"

class ADBDPlayer;

UCLASS(Blueprintable, Abstract)
class DBDGAMEPLAY_API ASmokeBombCosmeticHelperActor : public AActor
{
	GENERATED_BODY()

private:
	UFUNCTION(BlueprintCallable)
	void OnFirstPersonChanged(bool isFirstPerson);

	UFUNCTION(BlueprintPure)
	ADBDPlayer* GetOwningPlayer() const;

protected:
	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent, BlueprintCosmetic)
	void Cosmetic_UpdateVisibility(bool isVisible);

	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent, BlueprintCosmetic)
	void Cosmetic_OnSmokeStarted();

	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent, BlueprintCosmetic)
	void Cosmetic_OnSmokeEnded();

public:
	ASmokeBombCosmeticHelperActor();
};

FORCEINLINE uint32 GetTypeHash(const ASmokeBombCosmeticHelperActor) { return 0; }
